unit Advdde;
{*
** Entered into the Public Domain by David A. Rigsby on December 29, 1995.
** Use this unit and Functions at your own risk. Feel free to modify and
** redistribute on the condition that any revisions keep this original
** header or in some way bears the name of the Author and those who may
** have modified and redistributed it. Always remember, Give Credit where
** Credit is due.... and you will feel SOOOOOOO Good about yourself..
** Ompa loompa dompa de do.....
*}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DdeMan, StdCtrls,GroupTyp,ShellApi;

type
  TForm1 = class(TForm)
    CBGroups: TComboBox;
    Label1: TLabel;
    LBItems: TListBox;
    DDEClient: TDdeClientConv;
    imAppIcon: TImage;
    lbItemName: TLabel;
    lbWorkingDir: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbCmdLine: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LBItemsClick(Sender: TObject);
    procedure CBGroupsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  tsItems: TStringList;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   {*
   ** Instanciate our little TStringList
   ** Object so that we can use it. If you
   ** try to address or reference the TStringList
   ** object you have declared BEFORE using the Create
   ** Method.. You WILL GPF!  Also, If you get creative and
   ** Decide to sort the tsItems StringList, remeber to sort the
   ** LBItems Listbox as well or else all Havoc could break lose.
   *}
     tsItems:=TStringList.Create;

     DDEClient.SetLink('Progman','Progman');
     DDEClient.OpenLink;
     CBGroups.Items.SetText(DDEClient.RequestData('Groups'));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     tsItems.Free;
     DDEClient.CloseLink;
end;

procedure TForm1.LBItemsClick(Sender: TObject);
var
   tGroupInfo: TGroupInfo_T;
   oIcon: TICON;
   szIconFile: PChar;

begin
  {*
  ** Get all the information we need from the
  ** tsItems StringList.
  *}
  ParseGroupItems(tsItems.Strings[LBItems.ItemIndex],tGroupInfo);

  {*
  ** Fill in the Dialog Fields
  *}
    lbItemName.Caption:=tGroupInfo.ItemName;
    lbWorkingDir.Caption:=tGroupInfo.WorkingDir;
    lbCmdLine.Caption:=tGroupInfo.CmdLine;

  {*
  ** Allocate the PChar so we can use it.
  *}
    szIconFile:=StrAlloc(Length(tGroupInfo.IconFile)+1);
    StrPCopy(szIconFile,tGroupInfo.IconFile);
  {*
  ** Extract the Icon from the Executable File
  *}
   oIcon:=TIcon.Create;
   oIcon.Handle:=ExtractIcon(hInstance,szIconFile,
                             tGroupInfo.IconIndex);
   {*
   ** If we got back a valid Handle,
   ** Assign it to the imAppIcon Image object
   *}
{   if oIcon.Handle <> 0 then}
      imAppIcon.Picture.Icon:=oIcon;
{   else
       imAppIcon.Picture.Clear;
}
   {*
   ** Get rid of the PChar storage we used
   *}
     StrDispose(szIconFile);
end;

procedure TForm1.CBGroupsChange(Sender: TObject);
var
  iItemCount: Longint;
  tGroupInfo: TGroupInfo_T;
  bReturn: BOOLEAN;

begin
   {*
    ** Set this to -1 in Order to start at the 0
    ** Element in the StringList since it is
    ** ZERO Based
   *}

   iItemCount:=-1;

   {*
   ** Clear the string List
   *}
   tsItems.Clear;

   {*
   ** Clear the LBItems ListBox
   *}
    LBItems.Clear;

   {*
   ** The CBGroups Box has been changed so we will
   ** Use the TEXT property of the CBGroups Combobox
   ** as the ITEM for our Request Data method. This
   ** asks PROGMAN to give us information about every
   ** item in the group. This is why we use the
   ** SETTEXT method in order to set our String list
   ** to the massive PChar values that will be sent
   ** back to us via this call.
   *}
   {*
   ** SOMETIMES THIS GPFs. I've No clue as to why, If it happens,
   ** Don't end the program just retry the selection. If anyone
   ** Can tell me why this GPFs and the First One Doesn't, PLEASE
   ** Let me know. I'm on the Compuserve Delphi Forum, Post a message
   ** to me or tell me via E-Mail at BranhamTch@aol.com.  Maybe this
   ** is one for the Borland Tech Support guys......
   *}
   tsItems.SetText(DDEClient.RequestData(CBGroups.Text));

   {*
   ** Delete the First Entry, this is always the GROUP name
   ** and information about the Group File itself; like,
   ** Where it lives etc etc etc. We don't want this.
   *}
   tsItems.Delete(0);

   {*
   ** Now that we've got the items, iterate through
   ** then, using the ParseGroupItems Funciton
   ** parse the information for each group. On this pass,
   ** all we want is the Item's Name.
   **
   ** Make sure the Comparison to be done states
   ** that while the iItemCount is Less than
   ** tsItems.Count-1. The -1 is because we are dealing
   ** with a ZERO based StringList. Our Item Counter will
   ** always be one less than the tsItems.Count because
   ** The Number of items does not change wether this is
   ** a ZERO based List or not. If this were not a ZERO
   ** based list then we would not have to subtract one
   ** from the count because our Counter would always equal
   ** the count.  I may not explain this properly so here is a
   ** quick diagram:
   **               StringList[0] = 'First Item'
   **               StringList[1] = 'Second Item'
   **               StringList[2] = 'Third Item'
   **       StringList.Count is 3.
   *}
   while iItemCount < (tsItems.Count-1) do
   begin
     {*
     ** Increment the Item Counter
     *}
     Inc(iItemCount);
     bReturn:=ParseGroupItems(tsItems.Strings[iItemCount],tGroupInfo);
     {*
     ** If the function could properly parse the
     ** Information, add this to the LBItems ListBox.
     *}
     if bReturn = TRUE then
        LBItems.Items.Add(tGroupInfo.ItemName);
   end;
end;

end.
