unit GroupTyp;
{*
** NOTE: Even though this is being entered into Public Domain, it may
**       in no wise be copied or reproduced in a literary work,
**       such as a Book, Video, Electronic Books, Code Sniplets,
**       etc, without the express consent of the Author, David Rigsby,
**       Who may be contacted via E-Mail at: BranhamTch@aol.com.
**       Im a nice guy, just give me a chance......
**
** NOTE** And if there is anybody out there looking for contributors
**        for Books, Videos, etc.. I'm your man. Just contact me
**        via E-Mail at BranhamTch@aol.com and I will be more than happy
**        to contribute my Hundreds of Code Samples and Sniplets that
**        have taken over 6 years to compile. Here are some of the
**        languages I am VERY,VERY,VERY Proficient in:
**
**        C DOS/Windows, C++ DOS/Windows, Pascal DOS, Pascal DELPHI,
**        UNIX Kornshell, UNIX C, AS/400 RPG, and many more. 
**
** Entered into the Public Domain by David A. Rigsby on December 29, 1995.
** Use this unit and Functions at your own risk. Feel free to modify and
** redistribute on the condition that any revisions keep this original
** header or in some way bears the name of the Author and those who may
** have modified and redistributed it. Always remember, Give Credit where
** Credit is due.... and you will feel SOOOOOOO Good about yourself..
** Ompa loompa dompa de do.....
*}

{*
** I have always wanted to be able to grab the information from PROGMAN
** about it's groups and items. Unfortunatley, Microsoft keeps most
** of the good methods and means undocumented or well hidden. I have been
** searching through the Microsoft Developer's CD now for about 8 or so
** months. A couple of days ago, by sheer chance, I found an obscure entry
** that noted how to get information of the Program Manager Items without
** Having to read the Group File and decipher it's format. I have
** always been able to get the groups but never the items. Anyway, this
** obscure paragraph mentioned that to obtain the item information in a group,
** all one must do is to make the request item the Group Name and DDE will
** pass back myriads of information in comma delimited form about each item
** in the group.  My chin hit the floor as I began to experiment. SUCESS!
** I got the inromation back, and it was indeed comma delimited. That's why
** I wrote this small unit. To parse out the information I wanted and to
** stuff it into a predefined nicely parsed structure.
** Walah!
*}

interface
uses SysUtils;

{*
** This is what I could figure out the Strucutre of the information
** passed back from the Program Manager Looks Like.
*}
type
   TGroupInfo_t = record
      ItemName : String;
      CmdLine: String;
      WorkingDir: String;
      IconFile: String;
      GroupPosition: longint;
      IconIndex: longint;
      Shortcutkey: longint;
      MinimizeFlag: longint;
   end;

{*
** There are two main functions, ParseGroupItems and ExtractCmdLine.
*}
Function ParseGroupItems(pszGroupInfo:string;var GroupInfo: TGroupInfo_t):BOOLEAN;
Function ExtractCmdLine(pszCmdLine: string): String;

implementation

{*
** ParseGroupItems:
** What does it do?: This function takes the input from the pszGroupInfo
**                   argument and parses it out into the GroupInfo
**                   Structure.
**
** Arguments:
**                           Name: pszGroupInfo
**                           Type: String
**                           Why:  This is one of the strings that was
**                                 passed back from the dde call that
**                                 contains the Item Information.
**
**                           Name: GroupInfo
**                           Type: TGroupInfo_t;
**                           Why:  The Information from pszGroupInfo
**                                 is parsed into this structure and
**                                 passed back to the calling routine.
**
** Returns:         TRUE: The Function Sucessfully Parse the Input.
**                  FALSE: The input could not be sucessfully parsed.
*}
Function ParseGroupItems(pszGroupInfo:string;var GroupInfo: TGroupInfo_t):BOOLEAN;
 var
 iDelimFound,iBaseDelim,iBaseLength,iPrevDelimFound: longint;
 pszDelim1,pszDelim2,pszDelim3: String;
 pszWorkString: String;

 begin

{*
** Set the Negative Result
*}
ParsegroupItems:=FALSE;

{*
** Do a quick sanity check on the length of the string. We know
** that anything less than 10 bytes is definitly not in the right
** format.
*}
if Length(pszGroupInfo) > 10 then
begin

{*
** Now that we've passed the first sanity check, set the
** Positive Return Code.
*}
  ParsegroupItems:=TRUE;
{*
** Set up the delimiters we will be using.
*}
  pszDelim1:=',';
  pszDelim2:='"';
  pszDelim3:=' ';

  {*
   ** Copy the Original String into a Working String
   ** Since we will need to modify it's contents
  *}
  pszWorkString:=pszGroupInfo;
  iBaseLength:=Length(pszWorkString);

{*
** Start parsing the Fields
** Basic Structure:
**       First we find one of the delimiters and remember where it
**       was found. For the ItemName and CmdLine, we want to strip
**       the QUOTES out of the string so we look for delimiter 2
**       and change it to a blank. By doing this, that position
**       will not be found in subsequent POS searches. After finding
**       the field delimter, delimiter 1, we know how long the
**       string is. We will use this value to specify the number of
**       bytes to copy on the COPY command. Actually, we will take the
**       difference between the iDelimFound and iPrevDelimFound to
**       calculate how large the value is (for all fields other than
**       Description, mainly because there is no previous delimiter
**       found so we start copying from position 2 until the iDelimFound-1
**       value).
*}
  {Description}
  iDelimFound:=Pos(pszDelim2,pszWorkString);
   pszWorkString[iDelimFound]:=' ';

  iDelimFound:=Pos(pszDelim2,pszWorkString);
   pszWorkString[iDelimFound]:=' ';

  iDelimFound:=Pos(pszDelim1,pszWorkString);

  pszWorkString[iDelimFound]:=' ';
  GroupInfo.ItemName:=Copy(pszWorkString,2,iDelimFound-1);
  iPrevDelimFound:=iDelimFound;

  {Command Line}
  iDelimFound:=Pos(pszDelim2,pszWorkString);
  iPrevDelimFound:=iDelimFound;
  pszWorkString[iDelimFound]:=' ';

  iDelimFound:=Pos(pszDelim2,pszWorkString);
  pszWorkString[iDelimFound]:=' ';


  GroupInfo.CmdLine:=Copy(pszWorkString,iPrevDelimFound+1,(iDelimFound-1)-(iPrevDelimFound));

{*
** Since the Command line can contain our main delimiter a Comma,
** scan for commas in the Command Line and change them to blanks. This
** will prevent subsequent POS searches from picking up the wrong
** delimiter. We can tell if the delimiter we found is in the command
** line if the iBasDelim value is less than the iDelimFound value.
** at this point, iDelimFound represents the High Boundary of the Command
** Line Value.
*}
 iBaseDelim:=Pos(pszDelim1,pszWorkString);
 while iBaseDelim < iDelimFound do
 begin
  iBaseDelim:=Pos(pszDelim1,pszWorkString);
  if iBaseDelim <= iDelimFound then pszWorkString[iBaseDelim]:=' ';
 end;

  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:=' ';

  iPrevDelimFound:=iDelimFound;

  {Working Directory}
  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:=' ';
  GroupInfo.WorkingDir:=Copy(pszWorkString,iPrevDelimFound+1,(iDelimFound-1)-(iPrevDelimFound));
  {*
  ** If no Working Directory was found, Extract the File Name & Path from the
  ** command line and use it as the basis for creating the Working Directory.
  *}
  if Length(GroupInfo.WorkingDir) <= 2 then
     GroupInfo.WorkingDir:=ExtractFilePath(ExtractCmdLine(GroupInfo.CmdLine));

  iPrevDelimFound:=iDelimFound;

  {Icon File & Path}
  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:=' ';
  GroupInfo.IconFile:=Copy(pszWorkString,iPrevDelimFound+1,(iDelimFound-1)-(iPrevDelimFound));
  iPrevDelimFound:=iDelimFound;

  {Group Position}
  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:=' ';
  iPrevDelimFound:=iDelimFound;

  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:=' ';

 {*
 ** If this fails, return FALSE because we could not properly parse
 ** the Input.
 *}
 try
 {*
 ** If you are RUNNING this under Delphi, the IDE will show you the GPF
 ** despite the fact we are trapping for it. I think there is a way to
 ** turn that off but I am still looking for it. Anyway, just continue
 ** if it does, the function will handle the exception without aborting
 ** the current process.
 *}
  GroupInfo.GroupPosition:=StrtoInt(Copy(pszWorkString,iPrevDelimFound+1,(iDelimFound-1)-(iPrevDelimFound)));
 except
  on EConvertError do ParseGroupItems:=FALSE;
 end;

  iPrevDelimFound:=iDelimFound;

  {Icon Index}
  iDelimFound:=Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound]:='|';

 {*
 ** If this fails, return FALSE because we could not properly parse
 ** the Input.
 *}
 try
 {*
 ** If you are RUNNING this under Delphi, the IDE will show you the GPF
 ** despite the fact we are trapping for it. I think there is a way to
 ** turn that off but I am still looking for it. Anyway, just continue
 ** if it does, the function will handle the exception without aborting
 ** the current process.
 *}

  GroupInfo.IconIndex:=StrtoInt(Copy(pszWorkString,iPrevDelimFound+1,(iDelimFound-1)-(iPrevDelimFound)));
 except
  on EConvertError do ParsegroupItems:=FALSE;
 end;

  iPrevDelimFound:=iDelimFound;

 end;
end;

{*
** ExtractCmdLine
** What does it do?: This function takes the input from the pszCmdLine
**                   argument and retrieves the Executable File Name & Path
**                   and Returns it to the Calling Routine.
**
** Arguments:
**                           Name: pszCmdLIne
**                           Type: String
**                           Why:  This represents the command line you
**                                 want to parse. For Instance, if the
**                                 Command Line Value looks like this:
**
**                                 c:\win95\notepad c:\documents\rigsby.txt
**
**                                 Where c:\win95\notepad is the program
**                                 and c:\documents\rigsby.txt is a parameter
**                                 being passed to it, this function will
**                                 pluck out the c:\win95\notepad and
**                                 return it to the calling routine.
**
** Returns:          STRING: representing the program name.
**
** Notes:            For those with special needs, this routine may be
**                   modified to pass the Parameters back as well in a
**                   var parameter. Since the function know where the parms
**                   start, it would be just a matter of Taking the
**                   length of the string and subtracting the iSpaceFound
**                   value from it to get the number of bytes to copy then
**                   using the iSpaceFound as the reference of where to
**                   start the COPY from.
*}

Function ExtractCmdLine(pszCmdLine: string): String;
var
   iSpaceFound: longint;
begin
    {*
    ** Our delimiter this time is merely a blank space.
    ** A blank Space indicates a break in the command line
    ** thus the end of the program name. I am not sure how
    ** this would fare in 32 bit environments where spaces
    ** are allowed in file names.
    *}
    iSpaceFound:=0;
    iSpaceFound:=Pos(' ',pszCmdLine);

   if iSpaceFound > 0 then
    ExtractCmdLine:=Copy(pszCmdLine,1,iSpaceFound)
   else
   ExtractCmdLine:=pszCmdLine;
end;


end.
